<?php
require_once( TIPALTI_PAYEE_IFRAME_BASE_PATH .'/includes/defuse/load.php' );
use Defuse\Crypto\Crypto;
use Defuse\Crypto\Key;
class BLING_Crypto{

    private function debug(){
        return false;
    }

    public function __construct(){
        
        $error = $this->check_key_error();
        if ($this->debug()) $this->log("Error check :". $error);
        if ($error) $this->generate_key_file();
    }

    private function generate_key_file(){  
        if ($this->debug()) $this->log("generate_key_file");
        $key = Key::createNewRandomKey();
        $key_string = $key->saveToAsciiSafeString();
        file_put_contents($this->key_file(), $key_string);
    }

    private function get_key(){
        $file = $this->key_file();
        return file_get_contents($file);
    }

    private function check_key_error(){
       
        $file = $this->key_file();
        if ($this->debug()) $this->log("key file exist? : ".$file);
        if (!file_exists($file)) return true;
        // check error
        $value = "A COOL PLUGIN";
        $key = $this->get_key();
        $enc = $this->enc($value);
        $dec = $this->dec($enc);

        if ($value != $dec) return true;
        else return false;
    }

    private function log($msg){
        $msg = $msg . "\n";
        file_put_contents($this->log_file(), $msg, FILE_APPEND);
    }

    private function log_file(){
        return TIPALTI_PAYEE_IFRAME_BASE_PATH ."/log.txt";
    }

    private function key_file(){
        return TIPALTI_PAYEE_IFRAME_BASE_PATH ."/tipalti.txt";
    }
   
    public function enc($value){
        if (!$value) return;
        $key = $this->get_key();
        $key = Key::loadFromAsciiSafeString($key);
        if ($this->debug()) { $this->log("key : ".Crypto::encrypt( $value, $key)); }
        return Crypto::encrypt( $value, $key);
    }

    public function dec($value){
        if (!$value) return;
        $key = $this->get_key();
        $key = Key::loadFromAsciiSafeString($key);
        try {
            $value = Crypto::decrypt($value, $key );
            return $value;
        } catch ( WrongKeyOrModifiedCiphertextException $e) {
            return new WP_Error( $e->getCode(), $e->getMessage() );
        }

    }   
}



