<?php
if(!class_exists('Tipalti_Iframe_Payee'))
{
    class Tipalti_Iframe_Payee
    {

        /**
         * Construct the plugin object
         */
        public function __construct()
        {
            add_action( 'edit_user_profile', array(&$this,'render_payee_fields' ));
            add_action( 'edit_user_profile_update', array(&$this,'save_payee_fields' ));
        } // END public function __construct


        /*
        * Sanitize and Save Tipalti Payee Identifier data
        *
        */

        public function save_payee_fields( $user_id ) {
            $payee_id = sanitize_text_field($_POST['tipalti_payee_id']);
            $is_payee = sanitize_text_field($_POST['tipalti_is_payee']);
            update_user_meta( $user_id, 'tipalti_payee_id', $payee_id  );
            update_user_meta( $user_id, 'tipalti_is_payee', $is_payee  );
            
        }


        public function render_payee_fields( $user ) { 
            $value = esc_attr(get_user_meta( $user->ID, 'tipalti_is_payee', true));
            if (!$value) $value = "";
        
            ?>

            <table class="form-table">
            <tr class="tipalti_payee">
            <th><label for="payee">Payee</label></th>
            <td>
            Allow Tipalti Payee IFRAME: <input type="checkbox" name="tipalti_is_payee" id="tipalti_is_payee" value="1" <?php checked($value);?>/>
            <td>
            Tipalti Payee Id : <input type="text" name="tipalti_payee_id" id="tipalti_payee_id" value="<?php echo esc_attr( get_the_author_meta( 'tipalti_payee_id', $user->ID ) ); ?>" class="regular-text" /><br/>
            </td>
            </tr>
            </table>
        <?php }


    }
}
